class Ton
{
    //44100Hz Samplerate, 16bit, Stereo

    private:
        static unsigned char kopf[44];
        static int zl,zh;                
        static unsigned char zll,zhh;                
        static unsigned char zahl1[4];
        static unsigned char zahl2[4];
        static long int z1;
        static long int z2;
        static int teiler; 
        static int  hi,lo,gesamt;
        static double wert;
        static double gross;

        double* links;
        double* rechts;
        long int anzahl_samples;
        long int anzahl_aktuell;

    public:
        Ton(long int anzahl_samples);
        Ton();

        void set(long int i, double l, double r);
        void setLinks(long int i, double l);
        void setRechts(long int i, double r);
        double getLinks(long int i);
        double getRechts(long int i);

        long int getSizeMax();
        long int getSizeAkt();
        void speicherfreigeben();
        void clear();  //alles Stille

        static double meinabs(double x);

        void lade(string filename);
        void speicher(string filename);
};

unsigned char Ton::kopf[44] = {  82,   73,   70,   70,   52,  177,    2,    0,   87,   65, 
                                86,   69,  102,  109,  116,   32,   16,    0,    0,    0, 
                                 1,    0,    2,    0,   68,  172,    0,    0,   16,  177, 
                                 2,    0,    4,    0,   16,    0,  100,   97,  116,   97, 
                                16,  177,    2,    0  };


int Ton::zl,Ton::zh;                
unsigned char Ton::zll,Ton::zhh;                
unsigned char Ton::zahl1[4] = {0,0,0,0};
unsigned char Ton::zahl2[4] = {0,0,0,0};
long int Ton::z1;
long int Ton::z2;
int Ton::teiler = 256; 
int  Ton::hi,Ton::lo,Ton::gesamt;
double Ton::wert;
double Ton::gross = 0.5*(255.0*256.0 + 255.0);

        Ton::Ton(long int anzahl_samples)
        {
            this->anzahl_samples = anzahl_samples;
            this->anzahl_aktuell = anzahl_samples;
            links  = new double[anzahl_samples];
            rechts = new double[anzahl_samples];
        }
        Ton::Ton()
        {
            this->anzahl_samples = 0;
            this->anzahl_aktuell = 0;
            links  = 0;
            rechts = 0;
        }

        void Ton::set(long int i, double l, double r)
        {
            links[i] = l;
            rechts[i] = r;
        }
        void Ton::setLinks(long int i, double l)
        {
            links[i] = l;
        }
        void Ton::setRechts(long int i, double r)
        {
            rechts[i] = r;
        }
        double Ton::getLinks(long int i)
        {
            return links[i];
        }
        double Ton::getRechts(long int i)
        {
            return rechts[i];
        }

        long int Ton::getSizeMax()
        {
            return anzahl_samples;
        }
        long int Ton::getSizeAkt()
        {
            return anzahl_aktuell;
        }

        void Ton::speicherfreigeben()
        {
            delete[] links;
            delete[] rechts;
        }
        void Ton::clear()
        {
            for(long int i=0;i<anzahl_samples;i++)
            {
                links[i]  = 0.0;
                rechts[i] = 0.0;
            }
        }

        double Ton::meinabs(double x)
        {
            if(x<0.0)
                return -x;
            else
                return x;
        }

        void Ton::lade(string filename)
        {
            ifstream file(filename.data(),ios::binary);
            for(int i=0;i<44;i++)
                kopf[i] = file.get();

    

            //Gre finden:
            anzahl_aktuell = 0;
            for(int i=3;i>=0;i--)
            {
                anzahl_aktuell*=256;
                anzahl_aktuell+=(long int)kopf[40+i];
            }
            anzahl_aktuell/=4;

            //Falls neues File grer als allokierter Speicher, dann enu allokieren:            
            if(anzahl_aktuell>anzahl_samples)
            {                
                speicherfreigeben();
                anzahl_samples = anzahl_aktuell;
                links  = new double[anzahl_aktuell];
                rechts = new double[anzahl_aktuell];
            }

            for(int i=0;i<anzahl_aktuell;i++)
            {
                 zl = file.get();
                 zh = file.get();
                 if(zl>127)
                     zl-=256;
            
                 if(zh>127)
                     zh-=256;

                 lo     =  zl;
                 if(lo<0)
                     lo+=256;
                 gesamt = (zh+128)*256;
                
                 gesamt+=lo;
                
                 links[i] = ((double)gesamt - gross)/gross;        

                 zl = file.get();
                 zh = file.get();
                 if(zl>127)
                     zl-=256;
            
                 if(zh>127)
                     zh-=256;

                 lo     =  zl;
                 if(lo<0)
                     lo+=256;
                 gesamt = (zh+128)*256;
                
                 gesamt+=lo;
                
                 rechts[i] = ((double)gesamt - gross)/gross;        
                 
            }    

            file.close();
        }   



        void Ton::speicher(string filename)
        {
            z1 = anzahl_aktuell*4+36;
            z2 = anzahl_aktuell*4;

            //KOPF bilden
            for(int i=0;i<4;i++)
            {  
                zahl1[i] = z1%teiler;
                z1/=256;
                kopf[4+i] = zahl1[i];
            }

            for(int i=0;i<4;i++)
            {
                zahl2[i] = z2%teiler;
                z2/=256;
                kopf[40+i] = zahl2[i];
            }

            ofstream file(filename.data(),ios::binary);
            for(int i=0;i<44;i++)
                file.put(kopf[i]);

            for(int i=0;i<anzahl_aktuell;i++)
            {
                wert = links[i];
            
                gesamt = (int)(wert*gross + gross);    
               
                hi = gesamt/256;
                lo = gesamt - hi*256;
            
                zh = hi-128;
            
                if(lo<=127)
                    zl = lo;
                else        
                    zl = lo-256;                  
                
                file.put(zl);    
                file.put(zh);    

                wert = rechts[i];
            
                gesamt = (int)(wert*gross + gross);    
               
                hi = gesamt/256;
                lo = gesamt - hi*256;
            
                zh = hi-128;
            
                if(lo<=127)
                    zl = lo;
                else        
                    zl = lo-256;                  
                
                file.put(zl);    
                file.put(zh);    
            }
            file.close();    
        }





